<?php
//------------------------------------------------------------------------
//
//  Trackback Template Class for MODx 0.9.5
//
//  Author  : soushi
//  Version : 1.00
//  Date    : 2007/11/4
//
//------------------------------------------------------------------------

class TrackbackTemplate{
  var $TemplatePath = '';      //Template Path
  var $PH           = array(); //Template Placeholder
  var $Cache        = array(); //Template Cache

  //-----------------------------------------------------
  // Class Constructure
  // 
  // $fPath  : string : Template Path
  // return  : none
  //-----------------------------------------------------
  function TrackbackTemplate($fPath=''){

    if( $fPath != '' ){
      $this->TemplatePath = $fPath;
    }else{
      $this->TemplatePath = str_replace('//','/',dirname(__FILE__)) .'/template/';
    }

  } 

  //-----------------------------------------------------
  // Show Template
  // 
  // $fTP    : string : Template Name(filename)
  // $fPH    : array  : Placeholder
  // return  : string : HTML code(or Error Message)
  //-----------------------------------------------------
  function Show($fTP,$fPH=''){
    global $_lang;

    //$file     : template filename(full path)
    //$output   : output data
    //$bf,af    : value for PH
    //$val,$key : value for foreach 

    if(! isset( $this->Cache[$fTP] )){
      //read file data
      if( !(strpos($fTP,'..') === FALSE)){return 'Invalid template name.';}
      $file = $this->TemplatePath . $fTP . '.txt';
      if(! is_file($file) ){return 'Template not found!'.$fTP;}
      $this->Cache[$fTP] = file_get_contents($file);
    }
    $output = $this->Cache[$fTP];

    //Placeholder Execute
    $bf = array();
    $af = array();
    if(! empty($_lang) ){
      foreach( $_lang as $key => $val){
	$bf[] = '[+' . $key . '+]';
	$af[] = $val;
      }
    }
    if(! empty($this->PH) ){
      foreach( $this->PH as $key => $val){
	$bf[] = '[+' . $key . '+]';
	$af[] = $val;
      }
    }
    if( $fPH != '' ){
      foreach( $fPH as $key => $val){
	$bf[] = '[+' . $key . '+]';
	$af[] = $val;
      }
    }
    if(! empty($bf) ){
      $output = str_replace($bf,$af,$output);
    }

    //Delete other Placeholder
    $output = preg_replace('/\[\+[a-zA-Z0-9-_]+\+\]/','',$output);

    return $output;
  }

  //-----------------------------------------------------
  // Add Placeholder(All template effected)
  // 
  // $fKey   : string  : PH key name
  // $fVal   : string  : data
  // return  : bool
  //-----------------------------------------------------
  function AddPlaceholder($fKey,$fVal){
    if( $fKey == '' ){return false;}
    $this->PH[$fKey] = $fVal;
    return true;
  }

  //-----------------------------------------------------
  // Delete Placeholder
  // 
  // $fKey   : string  : PH key name
  // return  : bool
  //-----------------------------------------------------
  function DelPlaceholder($fKey){
    if( $fKey == '' ){return false;}
    unset($this->PH[$fKey]);
    return true;
  }

}
?>
